﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Hippo;

namespace Candlesample
{
    public partial class Form1 : Form
    {
        SeriesList sList;
        SeriesList sList2;

        int time = 0;

        public Form1()
        {
            InitializeComponent();
        }

        /// <summary>
        /// 그리기
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button1_Click(object sender, EventArgs e)
        {
            this.hHippoChart1.SeriesListDictionary.Clear();

            HippoEngine en = new HippoEngine();
            en.DataType = DataSourceType.Excel;
            en.Query = "select * from [Sheet1$]";
            en.ConnectionString = @"Provider=Microsoft.ACE.OLEDB.12.0;Data Source='"+ System.IO.Directory.GetCurrentDirectory() +"\\주식차트샘플2.xls';Extended Properties='Excel 12.0;HDR=YES'";
           
            sList = en.GetSeriesListOfStock(DataSourceType.Excel, "년/월", "시가", "종가", "저가", "고가");

            sList.ChartType = ChartType.CandleStick;

            sList.SeriesCollection[0].Name = "주가";

            //sList.GraphArea.Grid.Interval = 10;
            //sList.GraphArea.Grid.GridDirection = GridDirection.Vertical;

            //sList.AxisFactor.XAxis.LabelFormat.FormatFlags = StringFormatFlags.DirectionVertical;
            //sList.AxisFactor.XAxis.Interval = 10;

            sList.AxisFactor.YAxis.SetAxisStep(10000, 40000, 5000);


            double tempMaxHighval = double.MinValue;
            double tempMaxLowval = double.MaxValue;

            SeriesItem Highitem = new SeriesItem();
            SeriesItem Lowitem = new SeriesItem();

            foreach (SeriesItem item in sList.SeriesCollection[0].items)
            {
                if (item.HighValue > tempMaxHighval)
                {
                    tempMaxHighval = item.HighValue;
                    Highitem = item;
                }

                if (item.LowValue < tempMaxLowval)
                {
                    tempMaxLowval = item.LowValue;
                    Lowitem = item;
                }

                if (item.IsDojiType)
                {

                }
            }

            if (Highitem != null)
            {
                Highitem.Balloon = new Balloon();
                Highitem.Balloon.BalloonType = BalloonType.Rectangle;
                Highitem.Balloon.HeightType = HeightType.Bottom;
                Highitem.Balloon.BackColor = Color.White;
                Highitem.Balloon.Label.Text = "최고가 : " + Highitem.HighValue.ToString();
            }

            if (Lowitem != null)
            {
                Lowitem.Balloon = new Balloon();
                Lowitem.Balloon.BalloonType = BalloonType.Rectangle;
                Lowitem.Balloon.HeightType = HeightType.Bottom;
                Lowitem.Balloon.BackColor = Color.White;
                Lowitem.Balloon.Label.Text = "최저가 : " + Highitem.LowValue.ToString();
            } 

            sList.AxisFactor.XAxis.UnitPixel = 22;

            sList.SeriesCollection[0].items[11].Balloon = new Balloon();
            sList.SeriesCollection[0].items[11].Balloon.BalloonType = BalloonType.Rectangle;
            sList.SeriesCollection[0].items[11].Balloon.BackColor = Color.White;
            sList.SeriesCollection[0].items[11].Balloon.HeightType = HeightType.Bottom;
            sList.SeriesCollection[0].items[11].Balloon.Label.Text = "\r\n ---주식 시세 정보---\r\n";
            sList.SeriesCollection[0].items[11].Balloon.Label.Text += "\r\n - 시가: " + sList.SeriesCollection[0].items[11].YStartValue.ToString("n0");
            sList.SeriesCollection[0].items[11].Balloon.Label.Text += "\r\n - 종가: " + sList.SeriesCollection[0].items[11].YValue.ToString("n0");
            sList.SeriesCollection[0].items[11].Balloon.Label.Text += "\r\n - 저가: " + sList.SeriesCollection[0].items[11].LowValue.ToString("n0");
            sList.SeriesCollection[0].items[11].Balloon.Label.Text += "\r\n - 고가: " + sList.SeriesCollection[0].items[11].HighValue.ToString("n0");
            sList.SeriesCollection[0].items[11].Balloon.Label.Text += "\r\n";

            

            this.hHippoChart1.LegendBox.Visible = false;
            this.hHippoChart1.SeriesListDictionary.Add(sList);
            this.hHippoChart1.DrawChart(); 
        }

        /// <summary>
        /// 차트 크기가 변경될때 발생하는 이벤트
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void hHippoChart1_ChartSizeChanged(object sender, EventArgs e)
        {
            // 새로고침
            this.hHippoChart1.DrawChart();
        }

        /// <summary>
        /// 실시간 차트형태로 보기 샘플
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button2_Click(object sender, EventArgs e)
        {
            this.hHippoChart1.SeriesListDictionary.Clear();
            this.timer1.Interval = 1000;

            sList2 = new SeriesList();
            sList2.ChartType = ChartType.CandleStick;
            sList2.SeriesCollection.Add(new Series());
            sList2.AxisFactor.XAxis.Interval = 2;

            // 실시간 셋 추가
            this.hHippoChart1.RealTimeList.Add(new Hippo.WindowsForm4.HippoRealTimeAttribute());

            this.hHippoChart1.SeriesListDictionary.Add(sList2);
            //this.hHippoChart1.DrawChart();

            this.timer1.Start();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            try
            {
                this.hHippoChart1.DrawRealTimeChart(sList.SeriesCollection[0].items[time], 10);

                time++;
            }
            catch 
            {
                this.timer1.Stop();
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.hHippoChart1.DrawChart();
        }
    }
}